import string

import Image
import ImageDraw
import ImageFont
import ImagePalette
import ImageTk
import ImageFont

from numarray import *

class Movie:

  ##########################
  def __init__(self,name,mode=None):
  ##########################
  
    self.name = name
    self.mode = mode
    self.starttime  = 0.
    self.stoptime   = 0.
    self.dt	 = 0.
    self.npic	 = 0
    self.numByte = 0
    self.numLine = 0
    self.headerlength = 0
    
    # self.film
    
    
  
  ##########################     
  def open(self,mode='r'):
  ##########################   
  
    numByte = 256
    
    # open the file
    self.film = open(self.name, mode) 
    
    ###################################
    # read the header and find numByte 
    ###################################
  
    self.header = self.film.read(256)
      
    if len(self.header) == 256: 						      
  
      self.film.seek(240)
      
      str1 = self.film.read(8)
      str2 = self.film.read(8)
    	       
      if (str1 !="        " and str2 !="        "):				      
    	self.numByte = string.atoi(str1)					 
    	self.numLine = string.atoi(str2)					 
      else:									      
    	self.numByte = 256							    
    	self.numLine = 192							    
    
      if self.mode == 'RGB':
        self.numLine =  self.numLine*3						      
	      

      if self.numByte < 256:							      
    	self.headerlength = 256 						      
      else:
    	self.headerlength = self.numByte
    
      #############################
      # go to the top of the file 
      #############################
    	
      self.film.seek(0) 
 
      # reading next label							      
      time = self.film.read(self.headerlength)				      
      
      if len(time) == self.headerlength:
      
        # record starttime
        self.starttime = string.atof(time[:8])					      

    	# reading next data							      
    	data = self.film.read(self.numByte*self.numLine)			      
    	if len(data) == self.numByte*self.numLine: 			      

    	  # add one pict							      
    	  self.npic = self.npic + 1							      
 
 	  #######################
	  # loop over all images
	  #######################
	
    	  ok = 1								      
 
    	  while ok:								      
 
    	    ok = 0								      
    	    # reading next label						      
    	    time = self.film.read(self.headerlength)				      
    	    if len(time) == self.headerlength:					      

    	      # reading next data						      
    	      data = self.film.read(self.numByte*self.numLine)		      
    	      if len(data) == self.numByte*self.numLine:			      
    		ok = 1								      
    		self.npic = self.npic + 1 						      
    		self.stoptime = string.atof(time[:8])					      
      
    # go to the top of the file  				      
    	      
    self.film.seek(0) 	
    
    if self.npic > 1:
      self.dt = (self.stoptime-self.starttime)/(self.npic-1)	
    else:
      self.dt = 0.


  ##########################     
  def info(self):
  ##########################   
  
    print '''
    -- %s  --

    initial time	    : %8.3f
    final   time	    : %8.3f
    dt  		    : %8.3f 
    number of images	    : %d 
    number of collumns      : %d
    number of lines	    : %d 
    length of header	    : %d 
    ''' % (self.name,self.starttime,self.stoptime,self.dt,self.npic,self.numByte,self.numLine,self.headerlength)  
 
 
  ##########################     
  def new(self,numByte,numLine):
  ##########################   
  
    self.numByte = numByte 
    self.numLine = numLine
    
    if self.numByte < 256:	      	  					      
      self.headerlength = 256	      	  					      
    else:				    
      self.headerlength = self.numByte    
    
    self.film = open(self.name, "w") 
    
  ##########################     
  def close(self):
  ##########################       
     
    self.film.close()
      
    
  ##########################     
  def read_one(self,mode=None):
  ##########################     
    
    # reading next label					      	             
    time = self.film.read(self.headerlength)
        									      
    if len(time) == self.headerlength:					      
    									      
      # record starttime						      
      self.current_time = string.atof(time[:8])			      	             

      # reading next data					      	             
      data = self.film.read(self.numByte*self.numLine)  	      	             
      if len(data) == self.numByte*self.numLine:			    

    	self.current_image = data
	
	if mode == "array":
	  return reshape(fromstring(data,'b'),(self.numLine,self.numByte))
	elif mode == "image":
	  return Image.fromstring("P",shape,(self.numByte,self.numLine))
	else:
	  return data	
	
	
  ###########################
  def write_pic(self,time,data):
  ###########################


    import string
   
    recsize = self.numByte
   
    record = '%8.3f' % time
   
    s1=string.ljust(record,240)
    s2=string.ljust(`self.numByte`,8)
    if self.mode == 'RGB':
      s3=string.ljust(`self.numLine/3`,8)
    else:
      s3=string.ljust(`self.numLine`,8)
    record = s1+s2+s3
    record= string.ljust(record,recsize)
   
    self.film.write(record)
    self.film.write(data)


  ###########################
  def write_pic_rgb(self,time,dataR,dataG,dataB):
  ###########################


    import string
   
    recsize = self.numByte
   
    record = '%8.3f' % time
   
    s1=string.ljust(record,240)
    s2=string.ljust(`self.numByte`,8)
    s3=string.ljust(`self.numLine`,8)
    record = s1+s2+s3
    record= string.ljust(record,recsize)
   
    self.film.write(record)
    self.film.write(dataR)
    self.film.write(dataG)
    self.film.write(dataB)
       			    

  ###########################			
  def get_img(self,data):			
  ###########################			
     '''
     can be replaced by read_one with option "image"
     '''	
     shape = (self.numByte,self.numLine)						
     image = Image.fromstring("P",shape,data)
     return image
     

###################################     
def append_h(numByte,numLine,datas):  
###################################

  newdata = ''
  
  # loop over the lines
  for j in range(numLine):
  
    j1 = j*numByte 		# set cursors
    j2 = j1 + numByte
    
    # loop over the images
    for data in datas:
    
      newdata = newdata + data[j1:j2]	# simply sum

  return newdata
      

   
