import sys,os,string,glob

from distutils.sysconfig import *
from distutils.core import setup,Extension
from distutils.command.build_ext import build_ext
from distutils.command.install import install
from distutils.command.install_data import install_data


long_description = """\
This module provides lots of tools used
to deal with Nbody particles models.
"""

INCDIRS=['.']
SCRIPTS = glob.glob('scripts/*')


class pNbody_install_data (install_data):
  def finalize_options (self):
    if self.install_dir is None:
      install_lib = self.get_finalized_command('install_lib')
      self.warn_dir = 0
      self.install_dir = os.path.normpath(os.path.join(install_lib.install_dir,"pNbody"))
      

     

setup 	(       name	       	= "pNbody",
       		version         = "3.0.33",
       		author	      	= "Revaz Yves",
       		author_email    = "yves.revaz@obs.unige.ch",
		url 		= "http://obswww.unige.ch/~revaz",
       		description     = "pNbody module",
		
		packages 	= ['pNbody'],
		
		cmdclass = {'install_data': pNbody_install_data},
		
                ext_modules 	= [Extension("pNbody.nbodymodule", 
				             ["src/nbodymodule/nbodymodule.c"],
					     include_dirs=INCDIRS),
			 	   Extension("pNbody.myNumeric", 
				             ["src/myNumeric/myNumeric.c"],
					     include_dirs=INCDIRS),
			 	   Extension("pNbody.mapping", 
				             ["src/mapping/mapping.c"],
					     include_dirs=INCDIRS),           
			 	   Extension("pNbody.cosmolib", 
				             ["src/cosmolib/cosmolib.c"],
					     include_dirs=INCDIRS)      					     
					                             
				   ],
				   

		data_files=[('config',glob.glob('./config/*parameters')),
		            ('config/rgb_tables',glob.glob('./config/rgb_tables/*')),
			    ('config/formats',glob.glob('./config/formats/*')),
		            ('plugins',glob.glob('./config/plugins/*')),
			    ('fonts',glob.glob('./fonts/*')),
			    ('tests',glob.glob('./tests/*')),
			    ('examples',glob.glob('./examples/*.dat')),
			    ('examples/scripts',glob.glob('./examples/scripts/*')),
			    ('examples/films',glob.glob('./examples/films/*')),
			    ('doc',glob.glob('./doc/man.ps'))
			    ],

			    
                scripts = SCRIPTS			    
 	)
		
